/*
 *  <Short Description>
 *  Copyright (C) 2023  Brett Terpstra
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef BLT_WITH_GRAPHICS_BATCH_2D_RENDERER_H
#define BLT_WITH_GRAPHICS_BATCH_2D_RENDERER_H

#include "blt/gfx/model.h"
#include "blt/gfx/shader.h"

namespace blt::gfx
{
    
    struct rectangle
    {
        float x, y, width, height;
    };
    
    class batch_renderer_2d
    {
        private:
            vertex_array* square_vao;
            shader_t* shader;
        public:
            /**
             * @param use_view_matrix should we use the view matrix when rendering? Defaults to false as the assumption is the view matrix is 3d
             */
            void create(bool use_view_matrix = false);
            void cleanup();
    };
    
}

#endif //BLT_WITH_GRAPHICS_BATCH_2D_RENDERER_H
